package com.muyu.data.mart.service.impl;



import com.alibaba.fastjson.JSONObject;
import com.muyu.cloud.background.common.BasicApi;
import com.muyu.cloud.background.domin.juhe.JuHeResult;
import com.muyu.cloud.background.domin.realname.RealNameReq;
import com.muyu.cloud.background.domin.realname.RealNameResp;
import com.muyu.cloud.background.domin.realname.juhe.RealNameJuHeReq;
import com.muyu.cloud.background.domin.realname.juhe.RealNameJuHeResp;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;



/**
 * @Author：weiran
 * @Package：com.muyu.data.mart.service.impl
 * @Project：cloud-background
 * @name：RealNameService
 * @Date：2024/9/5 19:27
 */
@Service("juhe-real-name")
public class RealNameServiceImpl implements BasicApi<RealNameReq, RealNameResp>{
    @Override
    public RealNameResp send(RealNameReq realNameResp) {

        RealNameJuHeReq realNameJuHeReq = RealNameJuHeReq.realNameJuHeReqBuild(realNameResp);
        JuHeResult<RealNameJuHeResp> realNameJuHeRespJuHeResult = null;
        try {
            realNameJuHeRespJuHeResult = sendApi(realNameJuHeReq);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return RealNameResp.builder()
                .code(String.valueOf(realNameJuHeRespJuHeResult.getErrorCode()))
                .msg(realNameJuHeRespJuHeResult.getReason())
                .build();
    }

    public JuHeResult<RealNameJuHeResp> sendApi(RealNameJuHeReq realNameJuHeReq) throws Exception{

        //调用第三方的方法
            String apiKey = "1abdb559b392ff72c789840e943e1d5f";
            //c00bc093c4d5aee149a8d2efb2f2c51c谢欣悦(次数已用完)
            //1a398917d330f5ec01ce1110c459ec45 张腾
            //1abdb559b392ff72c789840e943e1d5f 彭思睿
            //586eae3d5ee4cbf46cb1430fdb3f8428 杨闪闪
            String apiUrl = "http://op.juhe.cn/idcard/query";


            HashMap<String, String> map = new HashMap<>();
            map.put("key", apiKey);
            map.put("idcard", realNameJuHeReq.getIdCard());
            map.put("realname", realNameJuHeReq.getRealName());
            map.put("orderid", "");

            String queryString = params(map);
            URL url = new URL(apiUrl + "?" + queryString);
            HttpURLConnection connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");

            BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
            String inputLine;
            StringBuffer response = new StringBuffer();
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();
        System.out.println(response);
      //{"reason":"参数错误：身份证不合法","result":null,"error_code":210304} 或
      //{"reason":"成功","result":{"realname":"魏然","idcard":"321183200303152916","res":1},"error_code":0}
      StringBuffer stringBuffer = new StringBuffer(response);
      JSONObject jsonObject = JSONObject.parseObject(stringBuffer.toString());
      String reason = jsonObject.getString("reason");
      JSONObject resultObj = jsonObject.getJSONObject("result");
      String realname = resultObj.getString("realname");
      String idcard = resultObj.getString("idcard");
      int res = resultObj.getIntValue("res");
      int errorCode = jsonObject.getIntValue("error_code");
      return new JuHeResult<RealNameJuHeResp>(){{
          setErrorCode(errorCode);
          setReason(reason);
          setResult(
                  RealNameJuHeResp.builder()
                          .realName(realname)
                          .idCard(idcard)
                          .res(res)
                          .build()
            );
        }};

//        return new JuHeResult<RealNameJuHeResp>(){{
//            setErrorCode(0);
//            setReason("成功");
//            setResult(
//                    RealNameJuHeResp.builder()
//                            .realName(realNameJuHeReq.getRealName())
//                            .idCard(realNameJuHeReq.getIdCard())
//                            .res(0)
//                            .build()
//            );
//        }};

    }


    public static String params(Map<String, String> map) {
        return map.entrySet().stream()
                .map(entry -> {
                    try {
                        return entry.getKey() + "=" + URLEncoder.encode(entry.getValue(), StandardCharsets.UTF_8.toString());
                    } catch (Exception e) {
                        e.printStackTrace();
                        return entry.getKey() + "=" + entry.getValue();
                    }
                })
                .collect(Collectors.joining("&"));
    }
}
